#ifndef AFX_ONFIGMANAGER_H__9243DE9D_0F70_40F8_8F90_55436B952B37__INCLUDED_
#define AFX_ONFIGMANAGER_H__9243DE9D_0F70_40F8_8F90_55436B952B37__INCLUDED_
#include "editwing/editwing.h"
#include "OpenSaveDlg.h"



// AvP[VbZ[W
#define GPM_MRUCHANGED WM_APP+0

//=========================================================================
//@{ @pkg Gp.Main //@}
//@{
//	ݒ̈ꌳǗ
//
//	SetDocTypeŐ؂ւƁA^Cvˑ̍ڂ
//	K؂ɐ؂ւFX܂B
//@}
//=========================================================================

class ConfigManager : public ki::Object
{
public:

	ConfigManager();

	//@{ w肵Õt@Cp̕^Cv[h //@}
	int SetDocType( const ki::Path& fname );

	//@{ w肵ԍ̕^Cv[h //@}
	void SetDocTypeByMenu( int pos, HMENU m );

	//@{ w肵O̕^Cv[h //@}
	void SetDocTypeByName( const ki::String& nam );

	//@{ j[ڍ쐬 //@}
	void SetDocTypeMenu( HMENU m, UINT idstart );

	//@{ j[ڂ̃`FbNC //@}
	void CheckMenu( HMENU m, int pos );

	//@{ ݒ_CAO\ //@}
	bool DoDialog( const ki::Window& parent );

	//@{ init@CIuWFNg擾 //@}
	ki::IniFile& getImpl();

public:

	//@{ Undo񐔐l //@}
	int undoLimit() const;

	//@{ ̃JEg@ //@}
	bool countByUnicode() const;

	//@{ J/ۑ_CAOɏotB^̐ݒ //@}
	const ki::String& txtFileFilter() const;

	//@{ w莞̐܂Ԃ //@}
	int wrapWidth() const;

	//@{ ܂Ԃ@ //@}
	int wrapType() const;

	//@{ sԍ\H //@}
	bool showLN() const;

	//@{ \FEtHgȂ //@}
	const editwing::VConfig& vConfig() const;

	//@{ L[[ht@C(tpX) //@}
	ki::Path kwdFile() const;

	//@{ GreppOst@C //@}
	const ki::Path& grepExe() const;

	//@{ EChEŊJ[h //@}
	bool openSame() const;

	//@{ Xe[^Xo[\ //@}
	bool showStatusBar() const;
	void ShowStatusBarSwitch();

public:
	//@{ VKt@C̕R[hindex //@}
	int GetNewfileCsi() const;

	//@{ VKt@C̉sR[h //@}
	ki::lbcode GetNewfileLB() const;

public:
	//@{ [ŋߎgt@C]֒ǉ //@}
	void AddMRU( const ki::Path& fname );

	//@{ [ŋߎgt@C]j[̍\z //@}
	void SetUpMRUMenu( HMENU m, UINT id );

	//@{ [ŋߎgt@C]擾 //@}
	ki::Path GetMRU( int no ) const;

	//@{ ΉZbgXg擾 //@}
	CharSetList& GetCharSetList();

public:
	//@{ EChEʒuETCY //@}
	int GetWndX() const;
	int GetWndY() const;
	int GetWndW() const;
	int GetWndH() const;
	bool GetWndM() const;
	void RememberWnd( ki::Window* wnd );

private:

	ki::IniFile ini_;
	bool        sharedConfigMode_;
	CharSetList charSets_;

	// S̓IȐݒ
	int        undoLimit_;
	ki::String txtFilter_;
	ki::Path   grepExe_;
	bool       openSame_;
	bool       countbyunicode_;
	bool       showStatusBar_;
	bool       rememberWindowSize_;
	bool       rememberWindowPlace_;

	// EChETCYL
	bool wndM_; // maximized?
	int  wndX_, wndY_, wndW_, wndH_;

	// ^CṽXg
	struct DocType
	{
		// `t@CȂ
		ki::String        name;
		ki::String        pattern;
		ki::String        kwdfile;
		ki::String        layfile;

		// ݒ荀
		editwing::VConfig vc;
		int               wrapType;
		int               wrapWidth;
		bool              showLN;
	};
	typedef ki::olist<DocType> DtList;

	DtList           dtList_;
	DtList::iterator curDt_;

	// ŋߎgt@C̃Xg
	int mrus_;
	ki::Path mru_[20];

	// VKt@C֌W
	int        newfileCharset_;
	ki::String newfileDoctype_;
	ki::lbcode newfileLB_;

private:

	void LoadIni();
	void SaveIni();
	void LoadLayout( DocType* dt );
	bool MatchDocType( const unicode* fname, const unicode* pat );

private:

	friend struct ConfigDlg;
	NOCOPY(ConfigManager);
};



//-------------------------------------------------------------------------
#ifndef __ccdoc__

inline int ConfigManager::undoLimit() const
	{ return undoLimit_; }

inline const ki::String& ConfigManager::txtFileFilter() const
	{ return txtFilter_; }

inline int ConfigManager::wrapWidth() const
	{ return curDt_->wrapWidth; }

inline int ConfigManager::wrapType() const
	{ return curDt_->wrapType>0 ? wrapWidth() : curDt_->wrapType; }

inline bool ConfigManager::showLN() const
	{ return curDt_->showLN; }

inline const editwing::VConfig& ConfigManager::vConfig() const
	{ return curDt_->vc; }

inline ki::Path ConfigManager::kwdFile() const
	{ return ki::Path(ki::Path::Exe)+TEXT("type\\")+curDt_->kwdfile; }

inline const ki::Path& ConfigManager::grepExe() const
	{ return grepExe_; }

inline bool ConfigManager::openSame() const
	{ return openSame_; }

inline bool ConfigManager::showStatusBar() const
	{ return showStatusBar_; }

inline void ConfigManager::ShowStatusBarSwitch()
	{ showStatusBar_ = !showStatusBar_; SaveIni(); }

inline bool ConfigManager::countByUnicode() const
	{ return countbyunicode_; }

inline ki::IniFile& ConfigManager::getImpl()
	{ return ini_; }

inline CharSetList& ConfigManager::GetCharSetList()
	{ return charSets_; }

inline int ConfigManager::GetNewfileCsi() const
	{ return charSets_.findCsi( newfileCharset_ ); }

inline ki::lbcode ConfigManager::GetNewfileLB() const
	{ return newfileLB_; }

inline int ConfigManager::GetWndX() const
	{ return rememberWindowPlace_ ? wndX_ : CW_USEDEFAULT; }

inline int ConfigManager::GetWndY() const
	{ return rememberWindowPlace_ ? wndY_ : CW_USEDEFAULT; }

inline int ConfigManager::GetWndW() const
	{ return rememberWindowSize_ ? wndW_ : CW_USEDEFAULT; }

inline int ConfigManager::GetWndH() const
	{ return rememberWindowSize_ ? wndH_ : CW_USEDEFAULT; }

inline bool ConfigManager::GetWndM() const
	{ return rememberWindowSize_ & wndM_; }

//=========================================================================

#endif // __ccdoc__
#endif // AFX_ONFIGMANAGER_H__9243DE9D_0F70_40F8_8F90_55436B952B37__INCLUDED_
